<template>
	<view class="wrap">
		<uni-section :title="point.pointContent" type="line">
			<uni-forms ref="form" :modelValue="formData" :rules="rules" :label-width="300" label-position="top">
				<uni-forms-item label="检查结果" name="checkResult" required>
					<view class="uni-data-checkbox-wrap">
						<uni-data-checkbox v-model="formData.checkResult" :localdata="checkResults" />				
					</view>
				</uni-forms-item>	
				<uni-forms-item label="备注" name="remark">
				  <uni-easyinput v-model="formData.remark" type="textarea" :maxlength="-1" autoHeight placeholder="备注" />
				</uni-forms-item>
				<uni-file-picker  v-model="formData.attachList" 
				 fileMediatype="image" 
				 title="请上传附件"
				 limit="1"
				 @select="uploadSuccess"
				 @delete="deleteFile"></uni-file-picker>	
			</uni-forms>
		</uni-section>
		<button type="primary" @click="onSubmit" class="submit-BT">提交</button>		
	</view>
</template>

<script>
	import {upload} from '@/api/system/upload.js'	
	import {updateChecklistPoint,getchecklistRecord,checklistComplete} from '@/api/aqpt/checklistPoint.js'
	export default {
		data() {
			return {
				checkResults:[
					{text:"通过",value:1},
					{text:"不通过",value:-1},
				],
				formData:{
					checkResult:1,	
					remark:"",
					attachList:[]
				},
				rules:{},
				point:{},
				itemList:[]
			}
		},
		onLoad() {
			this.init()
		},
		methods: {
			init(){
				let point=uni.getStorageSync('point');
				this.point=point;
				this.getchecklistRecord()
				this.getLocation()
			},
			getchecklistRecord(){
				let {checklistId,recordId}=uni.getStorageSync('point');
				if(!checklistId)return
				getchecklistRecord(checklistId,recordId).then((res)=>{
					let itemList=res.data.itemList
					let point=null
					let points=[]
					for(let i=0;i<itemList.length;i++){
						if(itemList[i].children){
							itemList[i].children.map(child=>{
								child.recordList.map(pointitem=>{
									points.push(point)
								})
							})
						}else{
							itemList[i].recordList.map(pointitem=>{
									points.push(pointitem)
							})
							
						}						
					}
					this.itemList=points
					this.handles=points.filter(item=>(!item.checkResult&&item.pointId!==this.point.pointId))
				})
			},			
			getLocation(){
				const self=this;
				uni.getLocation({
					type: 'wgs84',
					success: function (res) {
						self.formData.dutyLongitude=res.longitude
						self.formData.dutyLatitude=res.latitude
					}
				});		
			},
			async onSubmit() {
				let point=uni.getStorageSync('point')
				let attachList=[]
				for(let i=0;i<this.formData.attachList.length;i++){
					let filePath=this.formData.attachList[i].url
					let fileresq=await upload({filePath,formData:{
						additions: `经度:${this.formData.dutyLongitude};纬度:${this.formData.dutyLatitude}`
					}}).catch(()=>{
						uni.showToast({
							icon:'none',
							title:"提交失败！"
						})	
					})
					if(fileresq.includes('html')){
						uni.showToast({
							icon:'none',
							title:"图片上传异常"
						})
						return
					}					
					fileresq=JSON.parse(fileresq)
					attachList.push(fileresq.data)		
				}
				await updateChecklistPoint({
					recordId:point.recordId,
					checklistId:point.checklistId,
					itemId:point.itemId,
					pointId:point.pointId,
					checkResult:this.formData.checkResult,
					remark:this.formData.remark,
					attachList,
				}).catch(()=>{
					uni.showToast({
						icon:'none',
						title:"提交失败！"
					})				
				})
				// uni.showToast({
				// 	icon:'none',
				// 	title:"提交成功！",
				// 	duration:1000,					
				// 	complete() {
				// 		uni.redirectTo({
				// 			url:`/pages/app_views/checkList/index/index?type=form&id=${point.checklistId}&recordId=${point.recordId}`
				// 		})
				// 	}
				// })
				// this.goOnNext();	
				let idx=this.itemList.findIndex(item=>item.pointId===point.pointId)
				this.itemList[idx].checkResult=this.formData.checkResult
				this.batchHandle()
			},
			// 批量处理未处理的
			batchHandle(){
				let point=uni.getStorageSync('point')
				if(this.handles.length<1){
					const key=this.itemList.find(item=>item.checkResult===-1)
					if(!key){
						checklistComplete(point.recordId,point.checklistId).then(()=>{
							uni.$emit('type',1)						
							uni.switchTab({
								url:'/pages/history/history'
							})
						}).catch(()=>{
							uni.showToast({
								icon:"none",
								title:"操作失败"
							})
						})
					}else{
						uni.showToast({
							icon:'none',
							title:"处理完毕请核实！",
							duration:1000,
							complete() {
								uni.redirectTo({
									url:`/pages/app_views/checkList/index/index?type=form&id=${point.checklistId}&recordId=${point.recordId}`
								})
							}
						})
					}				
				}
				let nextPoint=this.handles[0]
				this.formData={
					checkResult:1,	
					remark:"",
					attachList:[]
				}
				this.handles.shift()
				uni.setStorageSync('point',nextPoint);
				this.point=nextPoint;	
			},
			// 批量处理未处理的【按顺序走到最后一个】
			goOnNext(){
				let point=uni.getStorageSync('point')				
				let pointIdex=this.itemList.findIndex(item=>point.pointId===item.pointId)
				let handles=this.itemList.slice(pointIdex+1);			
				let nextPointIdx=handles.findIndex(item=>(!item.checkResult))
					nextPointIdx=nextPointIdx+pointIdex
				if(handles.length<1||nextPointIdx<0){
					uni.showToast({
						icon:'none',
						title:"处理完毕",
						duration:1000,
						complete() {
							uni.redirectTo({
								url:`/pages/app_views/checkList/index/index?type=form&id=${point.checklistId}&recordId=${point.recordId}`
							})
						}
					})	
					return
				}			
				this.formData={
					checkResult:1,	
					remark:"",
					attachList:[]
				}						
				let nextPoint=this.itemList[nextPointIdx+1]				
				uni.setStorageSync('point',nextPoint);//防止测试刷新数据丢失
				this.point=nextPoint;					
			},
			uploadSuccess(e){
				let attachList=JSON.parse(JSON.stringify(this.formData.attachList))
				attachList.push(e.tempFiles[0])
				this.formData.attachList=attachList
			},
			deleteFile(e){							
				let attachList=JSON.parse(JSON.stringify(this.formData.attachList))
				attachList.filter(item=>item.uuid!==e.tempFile.uuid)
				this.formData.attachList=attachList
			},			
		},
		onUnload() {			
			uni.removeStorageSync('point')
		}
	}
</script>

<style lang="scss" scoped>
.wrap{
	padding: 20rpx;
	.submit-BT {
		width: 750rpx;
		color: #4D73FF;
		text-align: center;
		font-size: 32rpx;
		padding-bottom: 68rpx;
		background-color: #fff;
		position: fixed;
		left: 0;
		bottom: 0;
		z-index: 99;
		box-shadow: 0px 0px 12px 0px #0000000A;
		border-radius: 8px 8px 0px 0px
	}
	::v-deep .uni-forms-item{
		.uni-forms-item__content{
			.uni-data-checkbox-wrap{
				height: 100%;
				display: flex;
				align-items: center;					
			}
	
		}		
	}
}
</style>
